Imports CrystalDecisions.CrystalReports.Engine
Imports CrystalDecisions.Shared
Imports System.Data.OleDb
Public Class Reports

    Private Sub Btnshow_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Btnshow.Click
        If Trvreports.SelectedNode.Text = "Area List" Then
            areas()
        End If
        If Trvreports.SelectedNode.Text = "Customer List" Then
            CustList()
        End If
        If Trvreports.SelectedNode.Text = "Employee List" Then
            Emp()
        End If

        If Trvreports.SelectedNode.Text = "Collections Area Wise" Then
            collec()
        End If
        If Trvreports.SelectedNode.Text = "Total Collections" Then
            totcollec()
        End If

        If Trvreports.SelectedNode.Text = "Collections Between Dates" Then
            Dtcollec()
        End If
        If Trvreports.SelectedNode.Text = "Customer A/c" Then
            custact()
        End If


    End Sub

    Public Sub databaseconnect(ByVal crp As Object)
        Dim Logoninfos As New TableLogOnInfos
        Dim Logoninfo As New TableLogOnInfo
        Dim Connectioninfo As New ConnectionInfo
        Dim crTables As Tables
        Dim crTable As Table

        With Connectioninfo

            .UserID = "ADMIN"
            .Password = ""
        End With
        crTables = crp.Database.Tables
        Try
            For Each crTable In crTables
                Logoninfo = crTable.LogOnInfo
                Logoninfo.ConnectionInfo = Connectioninfo
                crTable.ApplyLogOnInfo(Logoninfo)
                ''''' crTable.Location = Windows.Forms.Application.StartupPath & "\Rajucable.mdb;"
                ' database to be change.

                crTable.Location = "D:\Cable\bin\rajucable.mdb"

            Next
        Catch ex As Exception
            MsgBox(ex.Message, MsgBoxStyle.OkOnly)
        End Try
    End Sub

    Public Sub areas()
        ' to generate  List of area report
        Dim repoview As New RepView
        Dim repoarea As New RepAreas



        databaseconnect(repoarea)
        repoview.CrystalReportViewer1.ReportSource = repoarea

        repoview.Show()

    End Sub

    Public Sub CustList()

        ' to generate customer list  report
        Dim repoview As New RepView
        Dim repocust As New RepCust




        databaseconnect(repocust)
        repoview.CrystalReportViewer1.ReportSource = repocust

        repoview.Show()

    End Sub

    Public Sub Emp()
        ' to generate  List of employees report
        Dim repoview As New RepView
        Dim repoemp As New EmpList



        databaseconnect(repoemp)
        repoview.CrystalReportViewer1.ReportSource = repoemp

        repoview.Show()

    End Sub

    Private Sub Reports_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load
        combofill(Comarea, "select areacode from marea")
        Grparea.Visible = False
        Grpcust.Visible = False
        Grpdt.Visible = False


    End Sub
    Public Sub custact()
        ' to generate  List of customer A/c  report
        Dim repoview As New RepView
        Dim repocoll As New RepcustAC


        If Comarea.Text = "" Then
            MessageBox.Show("Select Area")
            Exit Sub

        End If

        If Cmbcusto.Text = "" Then
            MessageBox.Show("Select Customer")
            Exit Sub

        End If

        ' to find  card no
        Dim k As Integer
        Dim n As String


        n = Cmbcusto.Text
        k = (n.Substring(0, n.IndexOf("-")))

        repocoll.RecordSelectionFormula = " {collections.cardno} = " & k & " "
        repocoll.DataDefinition.FormulaFields("Fcard").Text = " " & k & " "

        databaseconnect(repocoll)
        repoview.CrystalReportViewer1.ReportSource = repocoll

        repoview.Show()

    End Sub

    Public Sub collec()
        ' to generate  List of colection area wise  report
        Dim repoview As New RepView
        Dim repocoll As New Repcollect


        If Comarea.Text = "" Then
            MessageBox.Show("Select Area")
            Exit Sub


        End If

        repocoll.RecordSelectionFormula = " {collections.charges} =  0  And {collections.areacode}= '" & Comarea.SelectedItem & "'"
        repocoll.DataDefinition.FormulaFields("FArea").Text = "' " & Comarea.SelectedItem & " '"

        databaseconnect(repocoll)
        repoview.CrystalReportViewer1.ReportSource = repocoll

        repoview.Show()

    End Sub

    Private Sub Trvreports_AfterSelect(ByVal sender As Object, ByVal e As System.Windows.Forms.TreeViewEventArgs) Handles Trvreports.AfterSelect
        If Trvreports.SelectedNode.Text = "Area List" Then
            Grparea.Visible = False
            Grpcust.Visible = False
            Grpdt.Visible = False

        End If
        If Trvreports.SelectedNode.Text = "Customer List" Then
            Grparea.Visible = False
            Grpcust.Visible = False
            Grpdt.Visible = False
        End If
        If Trvreports.SelectedNode.Text = "Employee List" Then
            Grparea.Visible = False
            Grpcust.Visible = False
            Grpdt.Visible = False
        End If

        If Trvreports.SelectedNode.Text = "Collections Area Wise" Then
            Grparea.Visible = True
            Grpcust.Visible = False
            Grpdt.Visible = False
        End If
        If Trvreports.SelectedNode.Text = "Customer A/c" Then
            Grparea.Visible = True
            Grpcust.Visible = True
            Grpdt.Visible = False
        End If
        If Trvreports.SelectedNode.Text = "Collections Between Dates" Then
            Grparea.Visible = False
            Grpcust.Visible = False
            Grpdt.Visible = True
        End If

        If Trvreports.SelectedNode.Text = "Total Collections" Then
            Grparea.Visible = False
            Grpcust.Visible = False
            Grpdt.Visible = False
        End If

    End Sub

    Private Sub Comarea_SelectedIndexChanged(ByVal sender As Object, ByVal e As System.EventArgs) Handles Comarea.SelectedIndexChanged
        combofill1(Cmbcusto, "select cardno,custname from Mcustomer where areacode = '" & Comarea.SelectedItem & "'")
    End Sub
    Public Sub totcollec()
        ' to generate  total  colection report
        Dim repoview As New RepView
        Dim repocoll As New RepTcollect

        repocoll.RecordSelectionFormula = " {collections.charges} =  0"

        databaseconnect(repocoll)
        repoview.CrystalReportViewer1.ReportSource = repocoll

        repoview.Show()

    End Sub

    Public Sub Dtcollec()
        ' to generate  total  collection between dates
        Dim repoview As New RepView
        Dim repocoll As New RepColDt

        repocoll.RecordSelectionFormula = " {collections.trandt} > #" & DTPfrm.Value & " # and {collections.trandt} < #" & DTPto.Value & "# "
        repocoll.DataDefinition.FormulaFields("Frmdt").Text = "' " & DTPfrm.Value & " '"
        repocoll.DataDefinition.FormulaFields("Todt").Text = "' " & DTPto.Value & " '"

        databaseconnect(repocoll)
        repoview.CrystalReportViewer1.ReportSource = repocoll

        repoview.Show()

    End Sub

    
End Class